# H(curl) finite element space

import netgen.gui
#gui tk
from ngsolve import *
from netgen.geom2d import unit_square
from netgen.csg import unit_cube
#mesh = Mesh(unit_square.GenerateMesh(maxh=0.3))
mesh = Mesh(unit_cube.GenerateMesh(maxh=1.732050807568877))

fes = HCurl(mesh, order=1)
fes.SetOrder(TRIG,2)
fes.SetOrder(TET,3)
fes.Update()
uce = GridFunction(fes, name="uce")
ucf = GridFunction(fes, name="ucf")
uc = GridFunction(fes, name="uc")
Draw (uce)
Draw (ucf)
Draw (uc)
Draw (curl(uce), mesh, "curl")
Draw (curl(ucf), mesh, "curl")
Draw (curl(uc), mesh, "curl")

print ("fes.ndof =", fes.ndof)
edge_dofs = fes.GetDofNrs(NodeId(EDGE,10))
print ("edgedofs: ", edge_dofs)
uce.vec[:] = 0
uce.vec[edge_dofs[0]] = 1
Redraw()

face_dofs = fes.GetDofNrs(NodeId(FACE,1))
print ("facedofs: ", face_dofs)
ucf.vec[:] = 0
#ucf.vec[face_dofs[0]] = 1
Redraw()

cell_dofs = fes.GetDofNrs(NodeId(CELL,1))
print ("tetdofs: ", cell_dofs)
uc.vec[:] = 0
uc.vec[cell_dofs[0]] = 1
Redraw()
